--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*1, g = playerColor.g*1,b = playerColor.b*1,a = 1}


local GoldMover = CreateFrame("Frame","InkedGoldBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	GoldMover:SetSize(350,24)
	GoldMover:SetFrameLevel(98)
	GoldMover:SetClampedToScreen(true)
	GoldMover:SetClampRectInsets(0, 0, 0,0)
	
	local GoldMoverText  = GoldMover:CreateFontString(nil, "OVERLAY")
	GoldMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	GoldMoverText:SetPoint("CENTER",GoldMover,"CENTER", 0,0); 
	GoldMoverText:SetText("")
	
	local InkedGoldBar = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedGoldBar:SetAllPoints(GoldMover)
	
	local Goldframe = CreateFrame("Frame", nil, InkedGoldBar, BackdropTemplateMixin and "BackdropTemplate")
	Goldframe:SetAllPoints(InkedGoldBar)
	Goldframe:EnableMouse(true)

	

local addon, ns = ... 
local C, F, G = unpack(ns)
local panel = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")	

local SILVER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-SilverIcon:%d:%d:1:0\124t";
local GOLD_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-GoldIcon:%d:%d:1:0\124t";
local COPPER_AMOUNT_TEXTURE = "\124TInterface\\MoneyFrame\\UI-CopperIcon:%d:%d:1:0\124t";
local GoldIcon = format(GOLD_AMOUNT_TEXTURE)
local SilverIcon = format(SILVER_AMOUNT_TEXTURE)
local CopperIcon = format(COPPER_AMOUNT_TEXTURE)

local Stat = CreateFrame("Frame","Gold")
	Stat:EnableMouse(true)
	--Stat:SetFrameStrata("BACKGROUND")
	--Stat:SetFrameLevel(99)
	
	local Text  = panel:CreateFontString(nil, "OVERLAY")
	Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Roboto.TTF", 18, "OUTLINE")
	--Text:SetPoint("BOTTOMRIGHT",Goldframe,"BOTTOMRIGHT", -250,10); 
	Text:SetAllPoints(Goldframe)
			

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
			local point, relativeTo, relativePoint, xOfs, yOfs = GoldMover:GetPoint(n)
			Inked.db.profile.GoldX = xOfs
			Inked.db.profile.GoldY = yOfs
			Inked.db.profile.GoldPoint = point
			GoldMoverText:SetText("Gold")
		end	
			GoldMover:SetSize(175,25)		
			Text:SetFont(LSM:Fetch("font", Inked.db.profile.Goldfont), Inked.db.profile.GoldFontSize, Inked.db.profile.GoldFontOutline)
			
end
			
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)
	

local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function SetGoldBar()	
	if(Inked.db.profile.lockframes == false) then
			GoldMover:ClearAllPoints()
			if Inked.db.profile.GoldPoint == nil then
				GoldMover:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
				--Text:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
			else
				GoldMover:SetPoint(Inked.db.profile.GoldPoint, UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
				--Text:SetPoint(Inked.db.profile.GoldPoint, UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
			end
			CreateMoverBackdrop(GoldMover)
			GoldMover:SetMovable(true)
			GoldMover:EnableMouse(true)
			GoldMover:RegisterForDrag("LeftButton")
			GoldMover:SetScript("OnDragStart", GoldMover.StartMoving)
			GoldMover:SetScript("OnDragStop", GoldMover.StopMovingOrSizing)
			GoldMover:SetUserPlaced(true)
		elseif Inked.db.profile.GoldPoint == nil then
				GoldMover:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
				--Text:SetPoint("BOTTOMRIGHT", UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
			else
				GoldMover:SetPoint(Inked.db.profile.GoldPoint, UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
				--Text:SetPoint(Inked.db.profile.GoldPoint, UIParent,Inked.db.profile.GoldX,Inked.db.profile.GoldY)
		end
end

   local Profit	= 0
	local Spent		= 0
	local OldMoney	= 0

	local function formatMoney(money)
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end
	end
	
	local function formatTextMoney(money)
		local gold = floor(math.abs(money) / 10000)
		local silver = mod(floor(math.abs(money) / 100), 100)
		local copper = mod(floor(math.abs(money)), 100)
		if gold ~= 0 then
			return format("%s"..GoldIcon.." %s"..SilverIcon.." %s"..CopperIcon, gold, silver, copper)
		elseif silver ~= 0 then
			return format("%s"..SilverIcon.." %s"..CopperIcon, silver, copper)
		else
			return format("%s"..CopperIcon, copper)
		end

	end
	-- local function FormatTooltipMoney(money)
		-- local gold, silver, copper = abs(money / 10000), abs(mod(money / 100, 100)), abs(mod(money, 100))
		-- local cash = ""
		-- cash = format("%d"..GoldIcon.." %d"..SilverIcon.." %d"..CopperIcon, gold, silver, copper)		
		-- return cash
	-- end	
	
	local function OnEvent(self, event)
	if Inked.db.profile.UseActionBars == false then return end
		if Inked.db.profile.GoldEnable == false then return end
			SetGoldBar()
		if event == "PLAYER_ENTERING_WORLD" then
			OldMoney = GetMoney()
		end		
		local NewMoney	= GetMoney()
		local Change = NewMoney-OldMoney -- Positive if we gain money		
		if OldMoney > NewMoney then		-- Lost Money
			Spent = Spent - Change
		else							-- Gained Moeny
			Profit = Profit- Change
		end		
		if OldMoney == NewMoney then		-- No Change 
			Profit = 0		
			else							-- Gained Moeny
			Profit = Profit + Change			
		end		
		Text:SetText(formatTextMoney(NewMoney))
		-- Setup Money Tooltip
		self:SetAllPoints(Text)
		--local myPlayerRealm = GetRealmName();
		--local myPlayerName  = UnitName("player");				
		--Stat:SetScript("OnLeave", function() GameTooltip:Hide() end)		
		OldMoney = NewMoney		
	end


	Stat:SetScript("OnMouseDown", function(self,button)
			ToggleBackpack()
	end)
	Stat:RegisterEvent("PLAYER_LOGIN")
	Stat:RegisterEvent("CINEMATIC_STOP")
	Stat:RegisterEvent("PLAYER_MONEY")
	Stat:RegisterEvent("SEND_MAIL_MONEY_CHANGED")
	Stat:RegisterEvent("SEND_MAIL_COD_CHANGED")
	Stat:RegisterEvent("PLAYER_TRADE_MONEY")
	Stat:RegisterEvent("TRADE_MONEY_CHANGED")
	Stat:RegisterEvent("PLAYER_ENTERING_WORLD")
	--Stat:SetScript("OnMouseDown", function() ToggleCharacter("TokenFrame") end)
	Stat:SetScript("OnEvent", OnEvent)

local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
		--InkedREPBar:Show()
		--print("walking")
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
		--InkedREPBar:Hide()
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
	if(inBattle == true) then	
		--InkedREPBar:Hide()
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
		--InkedREPBar:Show()		
	end
end
-- local InkedLoginFrame=CreateFrame("Frame")
		-- InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		--InkedLoginFrame:RegisterEvent("UPDATE_INVENTORY_Gold")
		-- InkedLoginFrame:RegisterEvent("MERCHANT_SHOW")
		-- InkedLoginFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
		-- InkedLoginFrame:SetScript("OnEvent", function(self, event) 
		-- if Inked.db.profile.UseActionBars == false then return end
		-- if Inked.db.profile.GoldEnable == false then return end
			-- SetGoldBar()
			-- StartBattlePetsFun()
			-- EndBattlePetsFun()
			-- ridingFun()
			-- walkingFun()												
		-- end)
		
